#include<bits\stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    long long n, q, tp2 = 1, qp = 0;
    cin>>n>>q;
    long long a[n], e[q], p[n];
    for(long long i = 0; i < n; i++)
    {
        cin>>a[i];
        if(a[i] > 1)
        {
            tp2 = 0;
        }
        if(a[i] == 0)
        {
            qp++;
        }
        p[i] = qp;
    }
    if(tp2 == 1)
    {
        for(long long i = 0; i < q; i++)
        {
            long long l, r, b0;
            cin>>l>>r;
            l -= 1;
            r -= 1;
            if(l == 0)
            {
                b0 = p[r];
            }
            else
            {
                b0 = p[r] - p[l - 1];
            }
            if(b0 == 0)
            {
                e[i] = 1;
            }
            else
            {
                e[i] = 0;
            }
        }
    }
    else
    {
        for(long long i = 0; i < q; i++)
        {
            long long l, r;
            cin>>l>>r;
            l -= 1;
            r -= 1;
            e[i] = a[l];
            for(long long j = l + 1; j <= r; j++)
            {
                e[i] = e[i] & a[j];
                if(e[i] == 0)
                {
                    j = r + 1;
                }
            }
        }
    }
    for(long long i = 0; i < q; i++)
    {
        cout<<e[i]<<endl;
    }
}